// Copyright (c) 2010 Robert V Mahoney Jr
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// Slightly mucked with by Kurt Eckhardt to work in my library...
#ifndef _HI2C_DEFINED_
#define _HI2C_DEFINED_
#ifdef __cplusplus
extern "C"
{
#endif

// From i2c.h

#define _I2C_DEFINED_
#define _I2C_ADDRTYPE_NONE_ 0
#define _I2C_ADDRTYPE_8BIT_ 1
#define _I2C_ADDRTYPE_16BIT_ 2

#ifdef H8_FAMILY_3694
#define _I2C_SPEED_SLOWEST_			0x0F
#define _I2C_SPEED_100KHZ_			0x0C
#define _I2C_SPEED_150KHZ_			0x05
#define _I2C_SPEED_200KHZ_			0x04
#define _I2C_SPEED_250KHZ_			0x03
#define _I2C_SPEED_300KHZ_			0x02
#define _I2C_SPEED_400KHZ_			0x01
#define _I2C_SPEED_571KHZ_			0x00
#define _I2C_SPEED_FASTEST_			0x00
#endif

#ifdef H8_FAMILY_3687
#define _I2C_SPEED_SLOWEST_			0x0F
#define _I2C_SPEED_100KHZ_			0x0C
#define _I2C_SPEED_150KHZ_			0x07
#define _I2C_SPEED_200KHZ_			0x05
#define _I2C_SPEED_250KHZ_			0x04
#define _I2C_SPEED_300KHZ_			0x03
#define _I2C_SPEED_400KHZ_			0x02
#define _I2C_SPEED_500KHZ_			0x01
#define _I2C_SPEED_714KHZ_			0x00
#define _I2C_SPEED_FASTEST_			0x00

#endif

#define _CLEAR_				0
#define _SET_				1



void HI2CInitialize (u8 _bBusSpeed);
void HI2CTerminate (void);
void HI2CWrite (u8 _bDeviceAddr, u8 _bAddressType, u16 _wIOAddress, u8 *_pbData, u16 _wWriteCount);
void HI2CRead (u8 _bDeviceAddr, u8 _bAddressType, u16 _wIOAddress, u8 *_pbData, u16 _wReadCount);
void HI2CShowAckError (u8 _bShowAckError);

extern u8 g_bError;

#ifdef __cplusplus
}
#endif

#endif
